@version 0.4
@warnings
@script modeler

ft=0;
//Edit
c1;
c2;
c3;
c4;
c5;
c6;

//Extrude
c7;
c8;
c9;
c10;
c11;
c12;

//Variables
radius = 1;
height_Y = 1;
turns = 1;
details = 10;
phase = 0;
shake = 0;
flare = 0;

extrude = false;
axis = Y;
extent = 1;
levels = 1;
smoothshift_offset = 0;


main
{
	currentlyr = lyrfg();
	
	selmode(USER);
	
	interface();
}

interface
{
	reqbegin("Spiral++ [0.4]");
	
	
	c1 = ctlminislider("Raggio",radius,1,100);
	c2 = ctlminislider("Altezza",height_Y,0,100);
	c3 = ctlminislider("Giri",turns,0,200);
	c4 = ctlminislider("Dettagli",details,1,100);
	c5 = ctlminislider("Sfasamento",phase,-100,100);
	c6 = ctlminislider("Scossa",shake,-100,100);
	c12 = ctlminislider("Svasatura",flare,-100,100);
	
	c7 = ctlcheckbox("Estrusione",extrude);
	
	c8 = ctlchoice("Asse",axis,@"X","Y","Z"@);
	ctlactive(c7, "toggleOn", c8);
    c9 = ctlminislider("Estensione",extent,1,100);
	ctlactive(c7, "toggleOn", c9);
	c10 = ctlminislider("Segmenti",levels,1,10);
	ctlactive(c7, "toggleOn", c10);
	c11 = ctlminislider("Valore spostamento",smoothshift_offset,-100,100);
	ctlactive(c7, "toggleOn", c11);
	
	
	if(ft==0)
	{
		general(1);
		ft=1;
	}
	
	ctlrefresh(c1,"general");
	ctlrefresh(c2,"general");
	ctlrefresh(c3,"general");
	ctlrefresh(c4,"general");
	ctlrefresh(c5,"general");
	ctlrefresh(c6,"general");
	ctlrefresh(c7,"general");
	ctlrefresh(c8,"general");
	ctlrefresh(c9,"general");
	ctlrefresh(c10,"general");
	ctlrefresh(c11,"general");
	ctlrefresh(c12,"general");
	
    return if !reqpost();
	
	reqend();
}

general: val
{
	delete();
	spiral(1);
	
	extrude = getvalue(c7);
	
	if(extrude==true)
	{
		extrude_function();
	}

}

extrude_function
{
	axis = getvalue(c8);
	extent = (getvalue(c9)) / 10;
	levels = getvalue(c10);
	smoothshift_offset = getvalue(c11);
	
	delete();
	spiral(1);
	extrude(axis,extent,levels);
	if(smoothshift_offset!=0)
	{
		smoothshift_function();
	}

	
}

smoothshift_function
{
	smoothshift_offset = getvalue(c11);
	
	selmode(USER);
	
	currSurf = nextsurface();

	selpolygon(CLEAR);
			
	selpolygon(SET, SURFACE, currSurf);

	copy();
	paste();
	flip();
			
	Smoothshift_Offset = (smoothshift_offset / 10);
			
	smoothshift(Smoothshift_Offset,100);
			
	selpolygon(CLEAR);
			
	if(Smoothshift_Offset<0)
	{
		flip();
	}
			
}

spiral: val
{

radius = getvalue(c1);
height_Y = getvalue(c2);
turns = getvalue(c3);
details = getvalue(c4);
phase = getvalue(c5);
shake = getvalue(c6);
flare = getvalue(c12);
	
delete();


editbegin();

	l = <0,0,0>;
	
	r = turns * details;
	
	for(x=0; x<=r; x++)
	{
		num = (x * 3.1415926536) / (details); 
		
			phase_a = (phase / 100);
			phase_b = -(phase / 100);
			
			shake_x = cos(x)*(shake/100);
		
			flare_XZ = (num*(flare/100));
		
			l.x = (cos(num)*(radius+phase_a+shake_x+flare_XZ));
			l.z = (sin(num)*(radius+phase_b+shake_x+flare_XZ));
		
			l.y = num * (height_Y / 10);
		
		num_point = (x + 1);
		p[num_point] = addpoint(l);
	}
	
	
	addcurve(p);
	
	
editend();	
}

toggleOn: value
{
   return(value);
}
